#include <iostream>
#include <vector>
#include <set>
using namespace std;
class segmenttree
{
private:
    vector <set<int>> tree;
    vector <int> arr;
    int n;
    void build(int l , int r , int node)
    {
        if(l == r)
        {
            tree[node].insert(arr[l]);
            return;
        }
        int mid = (r - l) / 2 + l;
        build(l , mid , node * 2);
        build(mid + 1 , r , node * 2 + 1);
        tree[node].insert(tree[node * 2].begin() , tree[node * 2].end());
        tree[node].insert(tree[node * 2 + 1].begin() , tree[node * 2 + 1].end());
    }
    void update(int l , int r , int node , int idx , int val)
    {
        if(l == r)
        {
            tree[node].clear();
            tree[node].insert(val);
            return;
        }
        int mid = (r - l) / 2 + l;
        if(idx <= mid) update(l , mid , node * 2 , idx , val);
        else update(mid + 1 , r , node * 2 + 1 , idx , val);
        tree[node].insert(tree[node * 2].begin() , tree[node * 2].end());
        tree[node].insert(tree[node * 2 + 1].begin() , tree[node * 2 + 1].end());
    }
    set <int> query(int l , int r , int node , int ql , int qr)
    {
        if(l > qr || r < ql) return {};
        if(ql <= l && r <= qr) return tree[node];
        int mid = (r - l) / 2 + l;
        set <int> left = query(l , mid , node * 2 , ql , qr);
        set <int> right = query(mid + 1 , r , node * 2 + 1 , ql , qr);
        set <int> result;
        result.insert(left.begin() , left.end());
        result.insert(right.begin() , right.end());
    }
public:
    segmenttree(vector <int> &nums)
    {
        arr = nums;
        n = nums.size();
        tree.resize(4 * n);
        build(1 , 0 , n - 1);
    }
    void update(int idx , int val)
    {
        update(1 , 0 , n - 1 , idx , val);
    }
    int query(int l , int r)
    {
        set <int> uniqueElements = query(1 , 0 , n - 1 , l , r);
        return uniqueElements.size();
    }
};
int coundDifferentElements(vector <int> &arr , vector<pair<int , int>> &queries)
{
    int n = arr.size();
    int countt = 0;
    segmenttree ssegmenttree(arr);
    for(auto query : queries)
    {
        int idx = query.first;
        int val = query.second;
        ssegmenttree.update(idx , val);
        for(int l = 0; l < n; l++)
        {
            for(int r = l; r < n; r++)
            {
                countt += ssegmenttree.query(l , r);
            }
        }
    }
    return countt;
}
int main()
{
    vector <int> arr = {1 , 2 , 1};
    vector <pair<int , int>> queries = {{1 , 3}};
    int result = coundDifferentElements(arr , queries);
    cout <<result << endl;
}
